//....... . . . . . . . . . . . . . . . . .AC LAMP DIMMER USING PIC16F877A ....... . . . . . . . . . . . . . . . . .
// Author: Goirik Dhar .  E-mail : goirik.dhar@gmail.com
// connect 10k pot with RA0 pin.
// connect zero crossing detector output pin with pin RB0.
// connect triac optocoupler led anode pin with RC6 pin of MCU.

// for zero crossing detector, I have used C814 optocoupler in series with a 270k resistor for 230v mains.
// for firing triac, I have used MOC3021 optocoupler.


int i;
int v=0;


void main() 
{
 OPTION_REG.F6=0;
 INTCON=0XD0;
 TRISB.F0=1;         // zero crossing detector Input pin
 TRISC.F6=0;         // triac firing pin
 ADC_init();
 for(;;){}
}


void interrupt()     // ISR
{
INTCON.F1=0;         // resetting interrupt flag to 0 .
 v=ADC_read(RA0);    // value of v can be manually changed(from 1023 to 0) to produce desired constant output.
 delay_us(10);
 for(i=0;i<v;i++)    // for loop to produce variable delay.
 {
  delay_us(4);
 }
 PORTC.F6=1;
 delay_us(50);       // triac firing pulse of 50 microseconds
 PORTC.F6=0;

}

// If you find any way to improve this project, please let me know.